/*
 * Created on 08.05.2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package BendpointStuff;

import java.util.ArrayList;
import java.util.List;

import org.eclipse.draw2d.Connection;
import org.eclipse.draw2d.geometry.Point;
import org.eclipse.gef.commands.Command;
import org.eclipse.gef.editpolicies.BendpointEditPolicy;
import org.eclipse.gef.requests.BendpointRequest;
import vocleditor.edit.VOCLAssociationRoleEditPart;
import BendpointStuff.CreateBendpointCommand;
import BendpointStuff.MoveBendpointCommand;
import BendpointStuff.DeleteBendpointCommand;
import org.eclipse.draw2d.ManhattanConnectionRouter;

/**
 * Handles Bendpoint Edit's
 * @author jan
 */
public class VOCLBendpointEditPolicy extends BendpointEditPolicy {
	/**
	   * This edit policy's method is called when a bendpoint creation is caused
	   * by user interactions.
	  **/
	  protected Command getCreateBendpointCommand(BendpointRequest request)
	  {

	  	CreateBendpointCommand com = new CreateBendpointCommand();
		Point p = request.getLocation();
		com.setLocation(p);
		Point ref1 = getConnection().getSourceAnchor().getReferencePoint();
		Point ref2 = getConnection().getTargetAnchor().getReferencePoint();
		com.setRelativeDimensions(p.getDifference(ref1),
						p.getDifference(ref2));
		com.setConnectionModel((VOCLAssociationRoleEditPart)request.getSource());
		com.setIndex(request.getIndex());
		return com;
	  }


	  /**
	   * This edit policy's method is called when a bendpoint displacement is caused
	   * by user interactions.
	  **/
	  protected Command getMoveBendpointCommand(BendpointRequest request) {
	  	MoveBendpointCommand com = new MoveBendpointCommand();
		Point p = request.getLocation();
		com.setLocation(p);
		Point ref1 = getConnection().getSourceAnchor().getReferencePoint();
		Point ref2 = getConnection().getTargetAnchor().getReferencePoint();
		com.setRelativeDimensions(p.getDifference(ref1),
						p.getDifference(ref2));
		com.setConnectionModel((VOCLAssociationRoleEditPart)request.getSource());
		com.setIndex(request.getIndex());
		return com;
	  }


	  /**
	   * This edit policy's method is called when a bendpoint deletion is caused
	   * by user interactions.
	  **/
	  protected Command getDeleteBendpointCommand(BendpointRequest request) {
		DeleteBendpointCommand com = new DeleteBendpointCommand();
		Point p = request.getLocation();
		com.setLocation(p);
		com.setConnectionModel((VOCLAssociationRoleEditPart)request.getSource());
		com.setIndex(request.getIndex());
		return com;
	  }

	  protected List createSelectionHandles() {
	  	// Wenn noch kein Routing-Constraint dranhngt eins einfgen, gibt sonst NullPointerExceptions
	  	if(getConnection().getConnectionRouter() instanceof ManhattanConnectionRouter)
	  		return null;
	  	if(getConnection().getRoutingConstraint() == null)
	  		getConnection().setRoutingConstraint(new ArrayList());
	  	return super.createSelectionHandles();
		}
	  
		protected Connection getConnection() {
			return (Connection)getHostFigure();
		}
		
}
