/*
 * VOCLEditor PlugIn for Eclipse
 *
 * Gruppe 4 - Sommersemester 2005  
 */
package vocleditor.commands;

import VOCLModel.AssociationRole;
import VOCLModel.ClassifierRole;
import VOCLModel.NavExp;


/**
 * Command for deleting an associationrole.
 */
public class DeleteAssociationRoleCommand extends org.eclipse.gef.commands.Command {
	private	AssociationRole associationrole;
	private NavExp parent; 
	private ClassifierRole AssociationTarget, AssociationSource;

	/**
	 * Constructor, simply set's the command name.
	 */
	public DeleteAssociationRoleCommand() {
		setLabel("delete association role");
	}

	/**
	 * Entry point for command execution.
	 */
	public void execute() {
		AssociationTarget = associationrole.getAssociationTarget();
		AssociationTarget.getSource().remove(associationrole);
		AssociationSource = associationrole.getAssociationSource();
		AssociationSource.getTarget().remove(associationrole);
		parent = associationrole.getNavExp();
		parent.getAssociationRoles().remove(associationrole);
	}
	
	/**
	 * Undo command execution.
	 */
	public void undo() {
		AssociationTarget.getSource().add(associationrole);
		AssociationSource.getTarget().add(associationrole);
		parent.getAssociationRoles().add(associationrole);
	}
	
	/**
	 * Redo command execution.
	 */
	public void redo() {
		execute();
	}

	/**
	 * Sets the association role.
	 * @param associationrole the association role to set
	 */
	public void setAssociationRole (AssociationRole associationrole) {
		this.associationrole = associationrole;
	}	
}
