/*
 * VOCLEditor PlugIn for Eclipse
 *
 * Gruppe 4 - Sommersemester 2005  
 */
package vocleditor.commands;

import org.eclipse.gef.commands.Command;

import VOCLModel.*;

/**
 * @author manaljav
 * Command for deleting a condition.
 */
public class DeleteConditionCommand extends Command {
	private	Condition condition;
	private NavExp parent;	

	/**
	 * Creates a new DeleteConditionCommand.
	 */
	public DeleteConditionCommand() {
		setLabel("delete condition");
	}
	
	/**
	 * Sets the condition to be deleted
	 * @param condition condition to be deleted
	 */
	public void setCondition(Condition condition)	{
		this.condition = condition;
	}

	/**
	 * Sets the parent constraint.
	 * @param newParent the parent to set
	 */
	public void setParent(NavExp newParent) {
		parent = newParent;
	}
	
	/**
	 * Entry point for command execution.
	 */
	public void execute() {
		parent.setCondition(null) ;		
	}

	/**
	 * Redo command execution.
	 */
	public void redo() {
		execute();
	}

	/**
	 * Undo command execution.
	 */
	public void undo() {
		parent.setCondition(condition);
	}	
}
