/*
 * Created on 28.06.2005
 *
 */
package vocleditor.commands;

import org.eclipse.gef.commands.Command;
import VOCLModel.Label;

/**
 * Command for resetting Label positions to automatical positioning
 * @author jan
 */
public class ResetLabelCommand extends Command {
	/** The label to reset */
	private Label label;
	
	/**
	 * The default constructor.
	 * @param label the label
	 */
	public ResetLabelCommand(Label label) {
		this.label = label;
		setLabel("Reset label position");
	}

	/**
	 * @see Command#execute()
	 */
	public void execute()
	{
		label.setCustomPosition(false);
		label.getAssociationRole().setName(label.getAssociationRole().getName()); // Fire change to parent
	}

	/**
	 * @see Command#redo()
	 */
	public void redo()
	{
		execute();
	}

	/**
	 * @see Command#undo()
	 */
	public void undo() {
		label.setCustomPosition(true);
		label.getAssociationRole().setName(label.getAssociationRole().getName()); // Fire change to parent
	}
	

}
