<?xml version="1.0" encoding="UTF-8"?>

<xsl:stylesheet version="1.0"
xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:voclmodel="http://VOCLModel" 
xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"> 

<xsl:output method="xml" version="1.0" encoding="UTF-8" doctype-system="gxl.dtd" indent="yes" /> 

<xsl:template match="/voclmodel:NavExp"> 

<gxl xmlns:xlink="http://www.w3.org/1999/xlink" xmlns:xalan="http://xml.apache.org/xalan" xmlns:lxslt="http://xml.apache.org/xslt">

<graph id="InstanceGraph">

  <!-- NavExp -->
  <node id="N{generate-id(.)}">
	<type xlink:href="NavExp%:RECT:java.awt.Color[r=0,g=0,b=0]::[NODE]:"/>
	<attr name="inLoop">
	  <boolean>false</boolean>
	</attr>
	<attr name="isNegated">
	  <boolean>false</boolean>
	</attr>
  </node>
   
  <!-- ClassifierRole -->
  <xsl:for-each select="classifierRoles" >  
    <node id="N{generate-id(.)}">
	<type xlink:href="ClassifierRole%:RECT:java.awt.Color[r=0,g=0,b=0]::[NODE]:"/>
	<attr name="name">
	  <string><xsl:value-of select="@name"/></string>
	</attr>
	<attr name="type">
	  <string><xsl:value-of select="@type"/></string>
	</attr>
    </node>
    <!-- Edge: NavExp -> ClassifierNode -->
    <edge id="E{generate-id(.)}" from="N{generate-id(/voclmodel:NavExp)}" to="N{generate-id(.)}">
	<type xlink:href="classifierNode%:SOLID_LINE:java.awt.Color[r=0,g=0,b=0]::[EDGE]:"/>
    </edge>
    <!-- Attribute -->
    <xsl:for-each select="attributes" >  
      <node id="N{generate-id(.)}">
	<type xlink:href="Attribute%:RECT:java.awt.Color[r=0,g=0,b=0]::[NODE]:"/>
	<attr name="type">
	  <string><xsl:value-of select="@type"/></string>
	</attr>
	<attr name="value">
	  <string><xsl:value-of select="@value"/></string>
	</attr>
	<attr name="name">
	  <string><xsl:value-of select="@name"/></string>
	</attr>
      </node>
      <!-- Edge: ClassifierNode -> Attribute -->
      <edge id="E{generate-id(.)}" from="N{generate-id(..)}" to="N{generate-id(.)}">
	  <type xlink:href="attribute%:SOLID_LINE:java.awt.Color[r=0,g=0,b=0]::[EDGE]:"/>
      </edge>
    </xsl:for-each>
  </xsl:for-each>

  <!-- AssociationRole -->
  <xsl:for-each select="associationRoles" >  
    <node id="N{generate-id(.)}">
	<type xlink:href="AssociationRole%:RECT:java.awt.Color[r=0,g=0,b=0]::[NODE]:"/>
	<attr name="name">
	  <string><xsl:value-of select="@name"/></string>
	</attr>
    </node>
    <!-- Edge: NavExp -> AssociationNode -->
    <edge id="E1{generate-id(.)}" from="N{generate-id(/voclmodel:NavExp)}" to="N{generate-id(.)}">
	<type xlink:href="associationNode%:SOLID_LINE:java.awt.Color[r=0,g=0,b=0]::[EDGE]:"/>
    </edge>
    <!-- Edge: AssociationNode -> source ClassifierNode -->
    <edge id="E2{generate-id(.)}" from="N{generate-id(.)}" to="N{generate-id(../classifierRoles[position()=substring-after(current()/@AssociationSource,'.')+1])}">
	<type xlink:href="source%:SOLID_LINE:java.awt.Color[r=0,g=0,b=0]::[EDGE]:"/>
    </edge>
    <!-- Edge: AssociationNode -> target ClassifierNode -->
    <edge id="E3{generate-id(.)}" from="N{generate-id(.)}" to="N{generate-id(../classifierRoles[position()=substring-after(current()/@AssociationTarget,'.')+1])}">
	<type xlink:href="target%:SOLID_LINE:java.awt.Color[r=0,g=0,b=0]::[EDGE]:"/>
    </edge>
  </xsl:for-each>

</graph>

</gxl>
</xsl:template>
</xsl:stylesheet>



