/*
 * VOCLEditor PlugIn for Eclipse
 *
 * Gruppe 4 - Sommersemester 2005  
 */
package vocleditor.dialog;

import org.eclipse.jface.dialogs.IDialogConstants;
import org.eclipse.jface.dialogs.TitleAreaDialog;
import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Text;

/**
 * Dialog window for the ocl string.
 * @author tugstugi
 */
public class OCLStringDialog extends TitleAreaDialog {
	private String oclString;
	
	/**
	 * The default constructor.
	 * @param parentShell the parent shell
	 * @param oclString the ocl string
	 */
	public OCLStringDialog(Shell parentShell, String oclString) {
		super(parentShell);
		this.oclString = oclString;		
	}
	
	/**
	 * Creates the dialog area.
	 * @param parent the parent composite
	 * @return the dialog area control
	 */
	protected Control createDialogArea(Composite parent){
		Composite composite = (Composite) super.createDialogArea(parent);
		Text text = new Text(composite, SWT.BORDER  | SWT.WRAP );
		text.setEditable( false );
		GridData gridData = new GridData( GridData.FILL_BOTH );
		text.setLayoutData(gridData);
		text.setText(oclString);
		return composite;
	}

	/**
	 * Creates contents.
	 * @param parent the parent composite
	 * @return the contents control
	 */
	protected Control createContents(Composite parent) {		
		Control content = super.createContents(parent);
		content.getShell().setText("OCL String");
		setTitle("OCL String");
		return content;
	}
	
	/**
	 * Creates only the OK Button.
	 * @param parent the parent composite
	 */
	protected void createButtonsForButtonBar(Composite parent) {
        createButton(parent, IDialogConstants.OK_ID, IDialogConstants.OK_LABEL, true);
	}
}
