/*
 * VOCLEditor PlugIn for Eclipse
 *
 * Gruppe 4 - Sommersemester 2005  
 */
package vocleditor.edit;

import org.eclipse.gef.commands.Command;
import org.eclipse.gef.editpolicies.ComponentEditPolicy;
import org.eclipse.gef.requests.GroupRequest;

import VOCLModel.*;
import vocleditor.commands.DeleteMethodCommand;

/**
 * EditPolicy for a method.
 */
public class MethodComponentEditPolicy extends ComponentEditPolicy {

		/**
		 * Constructs a new MethodComponentEditPolicy
		 */
		public MethodComponentEditPolicy() {
			super();
		}
		
		/**
		 * Creates the delete command
		 * 
		 * @see DeleteMethodCommand
		 * @see ComponentEditPolicy#createDeleteCommand(org.eclipse.gef.requests.GroupRequest)
		 */
		protected Command createDeleteCommand(GroupRequest deleteRequest) {
			ClassifierRole parent = (ClassifierRole)((Method) getHost().getModel()).getClassifierRole();
			if( getHost().getModel() instanceof Method ) {
					DeleteMethodCommand deleteCmd = new DeleteMethodCommand();
					deleteCmd.setParent(((Method) getHost().getModel()).getClassifierRole());
					deleteCmd.setMethod((Method) getHost().getModel());
					return deleteCmd;
				}
			return null;
		}
}
