/*
 * VOCLEditor PlugIn for Eclipse
 *
 * Gruppe 4 - Sommersemester 2005  
 */
package vocleditor.edit;

import org.eclipse.draw2d.geometry.Dimension;
import org.eclipse.draw2d.geometry.Rectangle;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.gef.EditPart;
import org.eclipse.gef.EditPolicy;
import org.eclipse.gef.GraphicalEditPart;
import org.eclipse.gef.Request;
import org.eclipse.gef.commands.Command;
import org.eclipse.gef.editpolicies.NonResizableEditPolicy;
import org.eclipse.gef.editpolicies.ResizableEditPolicy;
import org.eclipse.gef.editpolicies.XYLayoutEditPolicy;
import org.eclipse.gef.requests.CreateRequest;

import vocleditor.commands.CreateConstraintCommand;
import vocleditor.commands.SetConstraintCommand;
import VOCLModel.Constraint;
import VOCLModel.VOCLDiagram;

/**
 * EditPolicy for XY-Layout.
 */
public class VOCLXYLayoutEditPolicy extends XYLayoutEditPolicy {
	
	protected Command createAddCommand(EditPart child, Object constraint) {
		return null;
	}
	
	protected Command getCreateCommand(CreateRequest request) {
		Object	newObjectType = request.getNewObjectType();
		Command	createCommand = null;

		if( newObjectType == Constraint.class && getHost() instanceof VOCLEditPart ) {
			CreateConstraintCommand create = new CreateConstraintCommand();
			create.setConstraint( (Constraint) request.getNewObject() );
			create.setParent( (VOCLDiagram)getHost().getModel());
			create.setLocation(request.getLocation());
			createCommand = create;
		}  
		return createCommand;
	}
	
	protected Command getDeleteDependantCommand(Request request) {
		return null;
	}
	
	protected EditPolicy createChildEditPolicy(EditPart child) {
		if ( child instanceof VOCLConstraintEditPart )
			return new ResizableEditPolicy();
		else 
			return new NonResizableEditPolicy();
	}
	
	protected Dimension getMinimumSizeFor(GraphicalEditPart child) {
		return child.getContentPane().getMinimumSize();
	}
	
	protected Command createChangeConstraintCommand(EditPart child, Object constraint) 
	{
		SetConstraintCommand locationCommand = new SetConstraintCommand();
		locationCommand.setObject((EObject)child.getModel());
		locationCommand.setLocation((Rectangle)constraint);
		return locationCommand;
	}
}
