
package vocleditor.editor;

import org.eclipse.gef.commands.Command;
import org.eclipse.gef.requests.CreationFactory;
import org.eclipse.gef.tools.ConnectionCreationTool;
import org.eclipse.jface.dialogs.Dialog;
import org.eclipse.swt.widgets.Shell;

import vocleditor.commands.CreateAssociationRoleCommand;
import vocleditor.dialog.AssociationPropertiesDialog;
import VOCLModel.AssociationRole;
import VOCLModel.ClassifierRole;

/**
 * @author Stefan
 *
 */
public class VOCLConnectionCreationTool extends ConnectionCreationTool {
	/**
	 * create CreationTool
	 *
	 */
	public VOCLConnectionCreationTool() {
		super();
	}
	/**
	 * create Createtiontool
	 * @param factory
	 */
	
	public VOCLConnectionCreationTool(CreationFactory factory) {
		super(factory);
	}
	
	/**
	 * @see org.eclipse.gef.tools.AbstractTool#executeCurrentCommand()
	 */
	
	protected void executeCurrentCommand() {
	Command command=getCurrentCommand();
	Shell shell=this.getCurrentViewer().getControl().getShell();
	if((command instanceof CreateAssociationRoleCommand) && command.canExecute()){
		CreateAssociationRoleCommand create=(CreateAssociationRoleCommand)command;
		AssociationRole associationrole=create.getAssociationRole();
		ClassifierRole source= create.getSource();
		ClassifierRole target= create.getTarget();
		AssociationPropertiesDialog d = new AssociationPropertiesDialog(shell, associationrole,source ,target );
		d.open();
		if( d.getReturnCode() != Dialog.OK )
			return;
		create.setCommandAttributes(d.getSource(),d.getTarget(),d.getName());
	   }
	   
	   
				
	super.executeCurrentCommand();
	}
}
