package vocleditor.figures;


import org.eclipse.draw2d.Label;
import org.eclipse.draw2d.geometry.Rectangle;
import org.eclipse.gef.EditPart;
import org.eclipse.swt.graphics.Image;

import vocleditor.VOCLEditorConstants;

/**
 * A Figure for a VOCL Classifier Attribute.
 * @author gruppe4
 */
public class AttributeFigure extends Label
{
	/**
	 * creates a new AttributeFigure.
	 */
	public AttributeFigure() 
	{
	    setOpaque(true);
	    setSize( 50, 20 );
	    setBounds( new Rectangle( 0, 0, 100, 20 ) );
	    setIcon( new Image(null, AttributeFigure.class.getResourceAsStream( "icons/attribute.gif" )));
	}

	/**
	 * Called by the EditPart to set label background after selection state change.
	 * 
	 * @param selected SELECTED_PRIMARY, SELECTED, or SELECTED_NONE from GEF.EditPart
	 */
	public void setSelected( int selected )
	{
		if ( selected == EditPart.SELECTED_PRIMARY )  {
			setBackgroundColor( VOCLEditorConstants.ATTRIBUTE_SELECTED_PRIMARY_COLOR  );
		}
		else if ( selected == EditPart.SELECTED )  {
			setBackgroundColor( VOCLEditorConstants.ATTRIBUTE_SELECTED_COLOR  );
		}
		else {
			if ( getParent().getChildren().indexOf( this ) % 2 == 0 )
				setBackgroundColor( VOCLEditorConstants.ATTRIBUTE_COLOR );
			else
				setBackgroundColor( VOCLEditorConstants.ATTRIBUTE_COLOR_2 );
		}
		repaint();
	}
	
	/**
	 *  initially sets the background color after being added to a parent figure
	 * @see org.eclipse.draw2d.IFigure#addNotify()
	 */
	public void addNotify() {
		if ( getParent().getChildren().indexOf( this ) % 2 == 0 )
			setBackgroundColor( VOCLEditorConstants.ATTRIBUTE_COLOR );
		else
			setBackgroundColor( VOCLEditorConstants.ATTRIBUTE_COLOR_2 );	
		super.addNotify();
	}
}
