/**
 * <copyright>
 * </copyright>
 *
 * $Id: BoolOperation.java,v 1.5 2005/07/07 08:31:02 bjoernt Exp $
 */
package VOCLModel;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

import org.eclipse.emf.common.util.AbstractEnumerator;

/**
 * <!-- begin-user-doc -->
 * A representation of the literals of the enumeration '<em><b>Bool Operation</b></em>',
 * and utility methods for working with them.
 * <!-- end-user-doc -->
 * @see VOCLModel.VOCLModelPackage#getBoolOperation()
 * @model
 * @generated
 */
public final class BoolOperation extends AbstractEnumerator {
  /**
   * The '<em><b>Or</b></em>' literal value.
   * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
   * @see #OR_LITERAL
   * @model name="or"
   * @generated
   * @ordered
   */
	public static final int OR = 0;

  /**
   * The '<em><b>Xor</b></em>' literal value.
   * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
   * @see #XOR_LITERAL
   * @model name="xor"
   * @generated
   * @ordered
   */
	public static final int XOR = 1;

  /**
   * The '<em><b>Implies</b></em>' literal value.
   * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
   * @see #IMPLIES_LITERAL
   * @model name="implies"
   * @generated
   * @ordered
   */
	public static final int IMPLIES = 2;

  /**
   * The '<em><b>Or</b></em>' literal object.
   * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Or</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
   * @see #OR
   * @generated
   * @ordered
   */
	public static final BoolOperation OR_LITERAL = new BoolOperation(OR, "or");

  /**
   * The '<em><b>Xor</b></em>' literal object.
   * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Xor</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
   * @see #XOR
   * @generated
   * @ordered
   */
	public static final BoolOperation XOR_LITERAL = new BoolOperation(XOR, "xor");

  /**
   * The '<em><b>Implies</b></em>' literal object.
   * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Implies</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
   * @see #IMPLIES
   * @generated
   * @ordered
   */
	public static final BoolOperation IMPLIES_LITERAL = new BoolOperation(IMPLIES, "implies");

  /**
   * An array of all the '<em><b>Bool Operation</b></em>' enumerators.
   * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
   * @generated
   */
	private static final BoolOperation[] VALUES_ARRAY =
    new BoolOperation[]
    {
      OR_LITERAL,
      XOR_LITERAL,
      IMPLIES_LITERAL,
    };

  /**
   * A public read-only list of all the '<em><b>Bool Operation</b></em>' enumerators.
   * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
   * @generated
   */
	public static final List VALUES = Collections.unmodifiableList(Arrays.asList(VALUES_ARRAY));

  /**
   * Returns the '<em><b>Bool Operation</b></em>' literal with the specified name.
   * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
   * @generated
   */
	public static BoolOperation get(String name)
  {
    for (int i = 0; i < VALUES_ARRAY.length; ++i)
    {
      BoolOperation result = VALUES_ARRAY[i];
      if (result.toString().equals(name))
      {
        return result;
      }
    }
    return null;
  }

  /**
   * Returns the '<em><b>Bool Operation</b></em>' literal with the specified value.
   * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
   * @generated
   */
	public static BoolOperation get(int value)
  {
    switch (value)
    {
      case OR: return OR_LITERAL;
      case XOR: return XOR_LITERAL;
      case IMPLIES: return IMPLIES_LITERAL;
    }
    return null;	
  }

  /**
   * Only this class can construct instances.
   * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
   * @generated
   */
	private BoolOperation(int value, String name)
  {
    super(value, name);
  }

} //BoolOperation
