/**
 * <copyright>
 * </copyright>
 *
 * $Id: Method.java,v 1.14 2005/07/07 08:31:02 bjoernt Exp $
 */
package VOCLModel;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Method</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link VOCLModel.Method#getReturnType <em>Return Type</em>}</li>
 *   <li>{@link VOCLModel.Method#getClassifierRole <em>Classifier Role</em>}</li>
 *   <li>{@link VOCLModel.Method#getReturnVariable <em>Return Variable</em>}</li>
 *   <li>{@link VOCLModel.Method#getArguments <em>Arguments</em>}</li>
 *   <li>{@link VOCLModel.Method#getContext <em>Context</em>}</li>
 * </ul>
 * </p>
 *
 * @see VOCLModel.VOCLModelPackage#getMethod()
 * @model
 * @generated
 */
public interface Method extends ModelElement{
  /**
   * Returns the value of the '<em><b>Return Type</b></em>' attribute.
   * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Return Type</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
   * @return the value of the '<em>Return Type</em>' attribute.
   * @see #setReturnType(String)
   * @see VOCLModel.VOCLModelPackage#getMethod_ReturnType()
   * @model
   * @generated
   */
	String getReturnType();

  /**
   * Sets the value of the '{@link VOCLModel.Method#getReturnType <em>Return Type</em>}' attribute.
   * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
   * @param value the new value of the '<em>Return Type</em>' attribute.
   * @see #getReturnType()
   * @generated
   */
	void setReturnType(String value);

  /**
   * Returns the value of the '<em><b>Classifier Role</b></em>' container reference.
   * It is bidirectional and its opposite is '{@link VOCLModel.ClassifierRole#getMethod <em>Method</em>}'.
   * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Classifier Role</em>' container reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
   * @return the value of the '<em>Classifier Role</em>' container reference.
   * @see #setClassifierRole(ClassifierRole)
   * @see VOCLModel.VOCLModelPackage#getMethod_ClassifierRole()
   * @see VOCLModel.ClassifierRole#getMethod
   * @model opposite="method" required="true"
   * @generated
   */
	ClassifierRole getClassifierRole();

  /**
   * Sets the value of the '{@link VOCLModel.Method#getClassifierRole <em>Classifier Role</em>}' container reference.
   * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
   * @param value the new value of the '<em>Classifier Role</em>' container reference.
   * @see #getClassifierRole()
   * @generated
   */
	void setClassifierRole(ClassifierRole value);

  /**
   * Returns the value of the '<em><b>Return Variable</b></em>' reference.
   * It is bidirectional and its opposite is '{@link VOCLModel.VariableDeclaration#getReturningMethod <em>Returning Method</em>}'.
   * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Return Variable</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
   * @return the value of the '<em>Return Variable</em>' reference.
   * @see #setReturnVariable(VariableDeclaration)
   * @see VOCLModel.VOCLModelPackage#getMethod_ReturnVariable()
   * @see VOCLModel.VariableDeclaration#getReturningMethod
   * @model opposite="returningMethod"
   * @generated
   */
	VariableDeclaration getReturnVariable();

  /**
   * Sets the value of the '{@link VOCLModel.Method#getReturnVariable <em>Return Variable</em>}' reference.
   * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
   * @param value the new value of the '<em>Return Variable</em>' reference.
   * @see #getReturnVariable()
   * @generated
   */
	void setReturnVariable(VariableDeclaration value);

  /**
   * Returns the value of the '<em><b>Arguments</b></em>' reference list.
   * The list contents are of type {@link VOCLModel.VariableDeclaration}.
   * It is bidirectional and its opposite is '{@link VOCLModel.VariableDeclaration#getMethods <em>Methods</em>}'.
   * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Arguments</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
   * @return the value of the '<em>Arguments</em>' reference list.
   * @see VOCLModel.VOCLModelPackage#getMethod_Arguments()
   * @see VOCLModel.VariableDeclaration#getMethods
   * @model type="VOCLModel.VariableDeclaration" opposite="methods"
   * @generated
   */
	EList getArguments();

  /**
   * Returns the value of the '<em><b>Context</b></em>' reference.
   * It is bidirectional and its opposite is '{@link VOCLModel.Context#getContextMethod <em>Context Method</em>}'.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Context</em>' reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Context</em>' reference.
   * @see #setContext(Context)
   * @see VOCLModel.VOCLModelPackage#getMethod_Context()
   * @see VOCLModel.Context#getContextMethod
   * @model opposite="contextMethod"
   * @generated
   */
  Context getContext();

  /**
   * Sets the value of the '{@link VOCLModel.Method#getContext <em>Context</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Context</em>' reference.
   * @see #getContext()
   * @generated
   */
  void setContext(Context value);

} // Method
