/**
 * <copyright>
 * </copyright>
 *
 * $Id: VOCLModelFactoryImpl.java,v 1.20 2005/07/07 08:31:02 bjoernt Exp $
 */
package VOCLModel.impl;

import VOCLModel.*;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EDataType;
import org.eclipse.emf.ecore.EObject;

import org.eclipse.emf.ecore.impl.EFactoryImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Factory</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class VOCLModelFactoryImpl extends EFactoryImpl implements VOCLModelFactory {
  /**
   * Creates an instance of the factory.
   * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
   * @generated
   */
	public VOCLModelFactoryImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
   * @generated
   */
	public EObject create(EClass eClass)
  {
    switch (eClass.getClassifierID())
    {
      case VOCLModelPackage.MODEL_ELEMENT: return createModelElement();
      case VOCLModelPackage.ATTRIBUTE: return createAttribute();
      case VOCLModelPackage.CLASSIFIER_ROLE: return createClassifierRole();
      case VOCLModelPackage.ASSOCIATION_ROLE: return createAssociationRole();
      case VOCLModelPackage.VOCL_DIAGRAM: return createVOCLDiagram();
      case VOCLModelPackage.CONSTRAINT: return createConstraint();
      case VOCLModelPackage.VOCL_EXPRESSION: return createVOCLExpression();
      case VOCLModelPackage.NAV_EXP: return createNavExp();
      case VOCLModelPackage.SET_CLASSIFIER_ROLE: return createSetClassifierRole();
      case VOCLModelPackage.METHOD: return createMethod();
      case VOCLModelPackage.VARIABLE_DECLARATION: return createVariableDeclaration();
      case VOCLModelPackage.CONTEXT: return createContext();
      case VOCLModelPackage.CONDITION: return createCondition();
      case VOCLModelPackage.BOOL_EXP: return createBoolExp();
      case VOCLModelPackage.IF_EXP: return createIfExp();
      case VOCLModelPackage.LET_EXP: return createLetExp();
      case VOCLModelPackage.LABEL: return createLabel();
      default:
        throw new IllegalArgumentException("The class '" + eClass.getName() + "' is not a valid classifier");
    }
  }

  /**
   * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
   * @generated
   */
	public Object createFromString(EDataType eDataType, String initialValue)
  {
    switch (eDataType.getClassifierID())
    {
      case VOCLModelPackage.BOOL_OPERATION:
      {
        BoolOperation result = BoolOperation.get(initialValue);
        if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
        return result;
      }
      default:
        throw new IllegalArgumentException("The datatype '" + eDataType.getName() + "' is not a valid classifier");
    }
  }

  /**
   * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
   * @generated
   */
	public String convertToString(EDataType eDataType, Object instanceValue)
  {
    switch (eDataType.getClassifierID())
    {
      case VOCLModelPackage.BOOL_OPERATION:
        return instanceValue == null ? null : instanceValue.toString();
      default:
        throw new IllegalArgumentException("The datatype '" + eDataType.getName() + "' is not a valid classifier");
    }
  }

  /**
   * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
   * @generated
   */
	public ModelElement createModelElement()
  {
    ModelElementImpl modelElement = new ModelElementImpl();
    return modelElement;
  }

  /**
   * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
   * @generated
   */
	public Attribute createAttribute()
  {
    AttributeImpl attribute = new AttributeImpl();
    return attribute;
  }

  /**
   * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
   * @generated
   */
	public ClassifierRole createClassifierRole()
  {
    ClassifierRoleImpl classifierRole = new ClassifierRoleImpl();
    return classifierRole;
  }

  /**
   * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
   * @generated
   */
	public AssociationRole createAssociationRole()
  {
    AssociationRoleImpl associationRole = new AssociationRoleImpl();
    return associationRole;
  }

  /**
   * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
   * @generated
   */
	public VOCLDiagram createVOCLDiagram()
  {
    VOCLDiagramImpl voclDiagram = new VOCLDiagramImpl();
    return voclDiagram;
  }

  /**
   * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
   * @generated
   */
	public Constraint createConstraint()
  {
    ConstraintImpl constraint = new ConstraintImpl();
    return constraint;
  }

  /**
   * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
   * @generated
   */
	public VOCLExpression createVOCLExpression()
  {
    VOCLExpressionImpl voclExpression = new VOCLExpressionImpl();
    return voclExpression;
  }

  /**
   * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
   * @generated
   */
	public NavExp createNavExp()
  {
    NavExpImpl navExp = new NavExpImpl();
    return navExp;
  }

  /**
   * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
   * @generated
   */
	public SetClassifierRole createSetClassifierRole()
  {
    SetClassifierRoleImpl setClassifierRole = new SetClassifierRoleImpl();
    return setClassifierRole;
  }

  /**
   * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
   * @generated
   */
	public Method createMethod()
  {
    MethodImpl method = new MethodImpl();
    return method;
  }

  /**
   * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
   * @generated
   */
	public VariableDeclaration createVariableDeclaration()
  {
    VariableDeclarationImpl variableDeclaration = new VariableDeclarationImpl();
    return variableDeclaration;
  }

  /**
   * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
   * @generated
   */
	public Context createContext()
  {
    ContextImpl context = new ContextImpl();
    return context;
  }

  /**
   * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
   * @generated
   */
	public Condition createCondition()
  {
    ConditionImpl condition = new ConditionImpl();
    return condition;
  }

  /**
   * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
   * @generated
   */
	public BoolExp createBoolExp()
  {
    BoolExpImpl boolExp = new BoolExpImpl();
    return boolExp;
  }

  /**
   * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
   * @generated
   */
	public IfExp createIfExp()
  {
    IfExpImpl ifExp = new IfExpImpl();
    return ifExp;
  }

  /**
   * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
   * @generated
   */
	public LetExp createLetExp()
  {
    LetExpImpl letExp = new LetExpImpl();
    return letExp;
  }

  /**
   * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
   * @generated
   */
	public Label createLabel()
  {
    LabelImpl label = new LabelImpl();
    return label;
  }

  /**
   * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
   * @generated
   */
	public VOCLModelPackage getVOCLModelPackage()
  {
    return (VOCLModelPackage)getEPackage();
  }

  /**
   * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
   * @deprecated
   * @generated
   */
	public static VOCLModelPackage getPackage()
  {
    return VOCLModelPackage.eINSTANCE;
  }

} //VOCLModelFactoryImpl
