/**
 * <copyright>
 * </copyright>
 *
 * $Id: VOCLModelAdapterFactory.java,v 1.16 2005/07/07 08:31:03 bjoernt Exp $
 */
package VOCLModel.util;

import VOCLModel.*;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notifier;

import org.eclipse.emf.common.notify.impl.AdapterFactoryImpl;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * The <b>Adapter Factory</b> for the model.
 * It provides an adapter <code>createXXX</code> method for each class of the model.
 * <!-- end-user-doc -->
 * @see VOCLModel.VOCLModelPackage
 * @generated
 */
public class VOCLModelAdapterFactory extends AdapterFactoryImpl {
  /**
   * The cached model package.
   * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
   * @generated
   */
	protected static VOCLModelPackage modelPackage;

  /**
   * Creates an instance of the adapter factory.
   * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
   * @generated
   */
	public VOCLModelAdapterFactory()
  {
    if (modelPackage == null)
    {
      modelPackage = VOCLModelPackage.eINSTANCE;
    }
  }

  /**
   * Returns whether this factory is applicable for the type of the object.
   * <!-- begin-user-doc -->
	 * This implementation returns <code>true</code> if the object is either the model's package or is an instance object of the model.
	 * <!-- end-user-doc -->
   * @return whether this factory is applicable for the type of the object.
   * @generated
   */
	public boolean isFactoryForType(Object object)
  {
    if (object == modelPackage)
    {
      return true;
    }
    if (object instanceof EObject)
    {
      return ((EObject)object).eClass().getEPackage() == modelPackage;
    }
    return false;
  }

  /**
   * The switch the delegates to the <code>createXXX</code> methods.
   * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
   * @generated
   */
	protected VOCLModelSwitch modelSwitch =
    new VOCLModelSwitch()
    {
      public Object caseModelElement(ModelElement object)
      {
        return createModelElementAdapter();
      }
      public Object caseAttribute(Attribute object)
      {
        return createAttributeAdapter();
      }
      public Object caseClassifierRole(ClassifierRole object)
      {
        return createClassifierRoleAdapter();
      }
      public Object caseAssociationRole(AssociationRole object)
      {
        return createAssociationRoleAdapter();
      }
      public Object caseVOCLDiagram(VOCLDiagram object)
      {
        return createVOCLDiagramAdapter();
      }
      public Object caseConstraint(Constraint object)
      {
        return createConstraintAdapter();
      }
      public Object caseVOCLExpression(VOCLExpression object)
      {
        return createVOCLExpressionAdapter();
      }
      public Object caseNavExp(NavExp object)
      {
        return createNavExpAdapter();
      }
      public Object caseSetClassifierRole(SetClassifierRole object)
      {
        return createSetClassifierRoleAdapter();
      }
      public Object caseMethod(Method object)
      {
        return createMethodAdapter();
      }
      public Object caseVariableDeclaration(VariableDeclaration object)
      {
        return createVariableDeclarationAdapter();
      }
      public Object caseContext(Context object)
      {
        return createContextAdapter();
      }
      public Object caseCondition(Condition object)
      {
        return createConditionAdapter();
      }
      public Object caseBoolExp(BoolExp object)
      {
        return createBoolExpAdapter();
      }
      public Object caseIfExp(IfExp object)
      {
        return createIfExpAdapter();
      }
      public Object caseLetExp(LetExp object)
      {
        return createLetExpAdapter();
      }
      public Object caseLabel(Label object)
      {
        return createLabelAdapter();
      }
      public Object defaultCase(EObject object)
      {
        return createEObjectAdapter();
      }
    };

  /**
   * Creates an adapter for the <code>target</code>.
   * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
   * @param target the object to adapt.
   * @return the adapter for the <code>target</code>.
   * @generated
   */
	public Adapter createAdapter(Notifier target)
  {
    return (Adapter)modelSwitch.doSwitch((EObject)target);
  }


  /**
   * Creates a new adapter for an object of class '{@link VOCLModel.ModelElement <em>Model Element</em>}'.
   * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
   * @return the new adapter.
   * @see VOCLModel.ModelElement
   * @generated
   */
	public Adapter createModelElementAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link VOCLModel.Attribute <em>Attribute</em>}'.
   * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
   * @return the new adapter.
   * @see VOCLModel.Attribute
   * @generated
   */
	public Adapter createAttributeAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link VOCLModel.ClassifierRole <em>Classifier Role</em>}'.
   * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
   * @return the new adapter.
   * @see VOCLModel.ClassifierRole
   * @generated
   */
	public Adapter createClassifierRoleAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link VOCLModel.AssociationRole <em>Association Role</em>}'.
   * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
   * @return the new adapter.
   * @see VOCLModel.AssociationRole
   * @generated
   */
	public Adapter createAssociationRoleAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link VOCLModel.VOCLDiagram <em>VOCL Diagram</em>}'.
   * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
   * @return the new adapter.
   * @see VOCLModel.VOCLDiagram
   * @generated
   */
	public Adapter createVOCLDiagramAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link VOCLModel.Constraint <em>Constraint</em>}'.
   * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
   * @return the new adapter.
   * @see VOCLModel.Constraint
   * @generated
   */
	public Adapter createConstraintAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link VOCLModel.VOCLExpression <em>VOCL Expression</em>}'.
   * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
   * @return the new adapter.
   * @see VOCLModel.VOCLExpression
   * @generated
   */
	public Adapter createVOCLExpressionAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link VOCLModel.NavExp <em>Nav Exp</em>}'.
   * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
   * @return the new adapter.
   * @see VOCLModel.NavExp
   * @generated
   */
	public Adapter createNavExpAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link VOCLModel.SetClassifierRole <em>Set Classifier Role</em>}'.
   * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
   * @return the new adapter.
   * @see VOCLModel.SetClassifierRole
   * @generated
   */
	public Adapter createSetClassifierRoleAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link VOCLModel.Method <em>Method</em>}'.
   * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
   * @return the new adapter.
   * @see VOCLModel.Method
   * @generated
   */
	public Adapter createMethodAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link VOCLModel.VariableDeclaration <em>Variable Declaration</em>}'.
   * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
   * @return the new adapter.
   * @see VOCLModel.VariableDeclaration
   * @generated
   */
	public Adapter createVariableDeclarationAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link VOCLModel.Context <em>Context</em>}'.
   * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
   * @return the new adapter.
   * @see VOCLModel.Context
   * @generated
   */
	public Adapter createContextAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link VOCLModel.Condition <em>Condition</em>}'.
   * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
   * @return the new adapter.
   * @see VOCLModel.Condition
   * @generated
   */
	public Adapter createConditionAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link VOCLModel.BoolExp <em>Bool Exp</em>}'.
   * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
   * @return the new adapter.
   * @see VOCLModel.BoolExp
   * @generated
   */
	public Adapter createBoolExpAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link VOCLModel.IfExp <em>If Exp</em>}'.
   * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
   * @return the new adapter.
   * @see VOCLModel.IfExp
   * @generated
   */
	public Adapter createIfExpAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link VOCLModel.LetExp <em>Let Exp</em>}'.
   * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
   * @return the new adapter.
   * @see VOCLModel.LetExp
   * @generated
   */
	public Adapter createLetExpAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link VOCLModel.Label <em>Label</em>}'.
   * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
   * @return the new adapter.
   * @see VOCLModel.Label
   * @generated
   */
	public Adapter createLabelAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for the default case.
   * <!-- begin-user-doc -->
	 * This default implementation returns null.
	 * <!-- end-user-doc -->
   * @return the new adapter.
   * @generated
   */
	public Adapter createEObjectAdapter()
  {
    return null;
  }

} //VOCLModelAdapterFactory
