/**
 * <copyright>
 * </copyright>
 *
 * $Id: VOCLModelSwitch.java,v 1.17 2005/07/07 08:31:03 bjoernt Exp $
 */
package VOCLModel.util;

import VOCLModel.*;

import java.util.List;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * The <b>Switch</b> for the model's inheritance hierarchy.
 * It supports the call {@link #doSwitch(EObject) doSwitch(object)}
 * to invoke the <code>caseXXX</code> method for each class of the model,
 * starting with the actual class of the object
 * and proceeding up the inheritance hierarchy
 * until a non-null result is returned,
 * which is the result of the switch.
 * <!-- end-user-doc -->
 * @see VOCLModel.VOCLModelPackage
 * @generated
 */
public class VOCLModelSwitch {
  /**
   * The cached model package
   * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
   * @generated
   */
	protected static VOCLModelPackage modelPackage;

  /**
   * Creates an instance of the switch.
   * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
   * @generated
   */
	public VOCLModelSwitch()
  {
    if (modelPackage == null)
    {
      modelPackage = VOCLModelPackage.eINSTANCE;
    }
  }

  /**
   * Calls <code>caseXXX</code> for each class of the model until one returns a non null result; it yields that result.
   * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
   * @return the first non-null result returned by a <code>caseXXX</code> call.
   * @generated
   */
	public Object doSwitch(EObject theEObject)
  {
    return doSwitch(theEObject.eClass(), theEObject);
  }

  /**
   * Calls <code>caseXXX</code> for each class of the model until one returns a non null result; it yields that result.
   * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
   * @return the first non-null result returned by a <code>caseXXX</code> call.
   * @generated
   */
	protected Object doSwitch(EClass theEClass, EObject theEObject)
  {
    if (theEClass.eContainer() == modelPackage)
    {
      return doSwitch(theEClass.getClassifierID(), theEObject);
    }
    else
    {
      List eSuperTypes = theEClass.getESuperTypes();
      return
        eSuperTypes.isEmpty() ?
          defaultCase(theEObject) :
          doSwitch((EClass)eSuperTypes.get(0), theEObject);
    }
  }

  /**
   * Calls <code>caseXXX</code> for each class of the model until one returns a non null result; it yields that result.
   * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
   * @return the first non-null result returned by a <code>caseXXX</code> call.
   * @generated
   */
	protected Object doSwitch(int classifierID, EObject theEObject)
  {
    switch (classifierID)
    {
      case VOCLModelPackage.MODEL_ELEMENT:
      {
        ModelElement modelElement = (ModelElement)theEObject;
        Object result = caseModelElement(modelElement);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case VOCLModelPackage.ATTRIBUTE:
      {
        Attribute attribute = (Attribute)theEObject;
        Object result = caseAttribute(attribute);
        if (result == null) result = caseModelElement(attribute);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case VOCLModelPackage.CLASSIFIER_ROLE:
      {
        ClassifierRole classifierRole = (ClassifierRole)theEObject;
        Object result = caseClassifierRole(classifierRole);
        if (result == null) result = caseModelElement(classifierRole);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case VOCLModelPackage.ASSOCIATION_ROLE:
      {
        AssociationRole associationRole = (AssociationRole)theEObject;
        Object result = caseAssociationRole(associationRole);
        if (result == null) result = caseModelElement(associationRole);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case VOCLModelPackage.VOCL_DIAGRAM:
      {
        VOCLDiagram voclDiagram = (VOCLDiagram)theEObject;
        Object result = caseVOCLDiagram(voclDiagram);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case VOCLModelPackage.CONSTRAINT:
      {
        Constraint constraint = (Constraint)theEObject;
        Object result = caseConstraint(constraint);
        if (result == null) result = caseModelElement(constraint);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case VOCLModelPackage.VOCL_EXPRESSION:
      {
        VOCLExpression voclExpression = (VOCLExpression)theEObject;
        Object result = caseVOCLExpression(voclExpression);
        if (result == null) result = caseModelElement(voclExpression);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case VOCLModelPackage.NAV_EXP:
      {
        NavExp navExp = (NavExp)theEObject;
        Object result = caseNavExp(navExp);
        if (result == null) result = caseVOCLExpression(navExp);
        if (result == null) result = caseModelElement(navExp);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case VOCLModelPackage.SET_CLASSIFIER_ROLE:
      {
        SetClassifierRole setClassifierRole = (SetClassifierRole)theEObject;
        Object result = caseSetClassifierRole(setClassifierRole);
        if (result == null) result = caseClassifierRole(setClassifierRole);
        if (result == null) result = caseModelElement(setClassifierRole);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case VOCLModelPackage.METHOD:
      {
        Method method = (Method)theEObject;
        Object result = caseMethod(method);
        if (result == null) result = caseModelElement(method);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case VOCLModelPackage.VARIABLE_DECLARATION:
      {
        VariableDeclaration variableDeclaration = (VariableDeclaration)theEObject;
        Object result = caseVariableDeclaration(variableDeclaration);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case VOCLModelPackage.CONTEXT:
      {
        Context context = (Context)theEObject;
        Object result = caseContext(context);
        if (result == null) result = caseModelElement(context);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case VOCLModelPackage.CONDITION:
      {
        Condition condition = (Condition)theEObject;
        Object result = caseCondition(condition);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case VOCLModelPackage.BOOL_EXP:
      {
        BoolExp boolExp = (BoolExp)theEObject;
        Object result = caseBoolExp(boolExp);
        if (result == null) result = caseVOCLExpression(boolExp);
        if (result == null) result = caseModelElement(boolExp);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case VOCLModelPackage.IF_EXP:
      {
        IfExp ifExp = (IfExp)theEObject;
        Object result = caseIfExp(ifExp);
        if (result == null) result = caseVOCLExpression(ifExp);
        if (result == null) result = caseModelElement(ifExp);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case VOCLModelPackage.LET_EXP:
      {
        LetExp letExp = (LetExp)theEObject;
        Object result = caseLetExp(letExp);
        if (result == null) result = caseVOCLExpression(letExp);
        if (result == null) result = caseModelElement(letExp);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case VOCLModelPackage.LABEL:
      {
        Label label = (Label)theEObject;
        Object result = caseLabel(label);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      default: return defaultCase(theEObject);
    }
  }

  /**
   * Returns the result of interpretting the object as an instance of '<em>Model Element</em>'.
   * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpretting the object as an instance of '<em>Model Element</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
	public Object caseModelElement(ModelElement object)
  {
    return null;
  }

  /**
   * Returns the result of interpretting the object as an instance of '<em>Attribute</em>'.
   * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpretting the object as an instance of '<em>Attribute</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
	public Object caseAttribute(Attribute object)
  {
    return null;
  }

  /**
   * Returns the result of interpretting the object as an instance of '<em>Classifier Role</em>'.
   * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpretting the object as an instance of '<em>Classifier Role</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
	public Object caseClassifierRole(ClassifierRole object)
  {
    return null;
  }

  /**
   * Returns the result of interpretting the object as an instance of '<em>Association Role</em>'.
   * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpretting the object as an instance of '<em>Association Role</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
	public Object caseAssociationRole(AssociationRole object)
  {
    return null;
  }

  /**
   * Returns the result of interpretting the object as an instance of '<em>VOCL Diagram</em>'.
   * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpretting the object as an instance of '<em>VOCL Diagram</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
	public Object caseVOCLDiagram(VOCLDiagram object)
  {
    return null;
  }

  /**
   * Returns the result of interpretting the object as an instance of '<em>Constraint</em>'.
   * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpretting the object as an instance of '<em>Constraint</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
	public Object caseConstraint(Constraint object)
  {
    return null;
  }

  /**
   * Returns the result of interpretting the object as an instance of '<em>VOCL Expression</em>'.
   * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpretting the object as an instance of '<em>VOCL Expression</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
	public Object caseVOCLExpression(VOCLExpression object)
  {
    return null;
  }

  /**
   * Returns the result of interpretting the object as an instance of '<em>Nav Exp</em>'.
   * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpretting the object as an instance of '<em>Nav Exp</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
	public Object caseNavExp(NavExp object)
  {
    return null;
  }

  /**
   * Returns the result of interpretting the object as an instance of '<em>Set Classifier Role</em>'.
   * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpretting the object as an instance of '<em>Set Classifier Role</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
	public Object caseSetClassifierRole(SetClassifierRole object)
  {
    return null;
  }

  /**
   * Returns the result of interpretting the object as an instance of '<em>Method</em>'.
   * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpretting the object as an instance of '<em>Method</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
	public Object caseMethod(Method object)
  {
    return null;
  }

  /**
   * Returns the result of interpretting the object as an instance of '<em>Variable Declaration</em>'.
   * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpretting the object as an instance of '<em>Variable Declaration</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
	public Object caseVariableDeclaration(VariableDeclaration object)
  {
    return null;
  }

  /**
   * Returns the result of interpretting the object as an instance of '<em>Context</em>'.
   * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpretting the object as an instance of '<em>Context</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
	public Object caseContext(Context object)
  {
    return null;
  }

  /**
   * Returns the result of interpretting the object as an instance of '<em>Condition</em>'.
   * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpretting the object as an instance of '<em>Condition</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
	public Object caseCondition(Condition object)
  {
    return null;
  }

  /**
   * Returns the result of interpretting the object as an instance of '<em>Bool Exp</em>'.
   * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpretting the object as an instance of '<em>Bool Exp</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
	public Object caseBoolExp(BoolExp object)
  {
    return null;
  }

  /**
   * Returns the result of interpretting the object as an instance of '<em>If Exp</em>'.
   * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpretting the object as an instance of '<em>If Exp</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
	public Object caseIfExp(IfExp object)
  {
    return null;
  }

  /**
   * Returns the result of interpretting the object as an instance of '<em>Let Exp</em>'.
   * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpretting the object as an instance of '<em>Let Exp</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
	public Object caseLetExp(LetExp object)
  {
    return null;
  }

  /**
   * Returns the result of interpretting the object as an instance of '<em>Label</em>'.
   * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpretting the object as an instance of '<em>Label</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
	public Object caseLabel(Label object)
  {
    return null;
  }

  /**
   * Returns the result of interpretting the object as an instance of '<em>EObject</em>'.
   * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch, but this is the last case anyway.
	 * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpretting the object as an instance of '<em>EObject</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject)
   * @generated
   */
	public Object defaultCase(EObject object)
  {
    return null;
  }

} //VOCLModelSwitch
